import ketai.sensors.*; 
double longitude, latitude;
KetaiLocation location;
PImage chicago;
PFont helvetica;
PFont interstate;
MercatorMap mercatorMap;

PVector zone;
PVector local;
int count;

Table congestion;

String src = "https://data.cityofchicago.org/resource/spqx-js37.csv";

void setup() {
  size(displayWidth, displayHeight);
  background(0);
  smooth();
  congestion = loadTable(src);

  chicago = loadImage("chicago_black2.png");
  interstate = loadFont("Interstate-Light-48.vlw");



  //mercatorMap = new MercatorMap(400, 516, 42.04, 41.63, -87.92, -87.49);
  mercatorMap = new MercatorMap(displayWidth, displayHeight, 42.04, 41.63, -87.92, -87.49);
  count = congestion.getRowCount();
}

void draw() {
  image(chicago, 0, 0, width, height);

  if (location.getProvider() == "none")
    text("Location data is unavailable. \n" +
      "Please check your location settings.", 0, 0, width, height);
  else
  textFont(interstate);
   fill(255);
 text("Location data:\n" + 
    "Latitude: " + latitude + "\n" + 
    "Longitude: " + longitude, 20, 0, width, height);

  float localat = (float)latitude;
  float localon = (float)longitude;
  fill(255);
  local = mercatorMap.getScreenLocation(new PVector(localat, localon));

  ellipse(local.x, local.y, 40, 40);


  for (int row =1; row < count; row++) {
    float lon = congestion.getFloat(row, 8);
    float lat = congestion.getFloat(row, 7);

    zone = mercatorMap.getScreenLocation(new PVector(lat, lon));
    noStroke();

    if (dist(local.x, local.y, zone.x, zone.y) > 200) {
      fill(255, 0, 0);
    } else {
      fill(0, 255, 0);
    }

    ellipse(zone.x, zone.y, 15, 15);
  }
}

void onResume()
{
  location = new KetaiLocation(this);
  super.onResume();
}

void onLocationEvent(Location _location)
{
  //print out the location object
  println("onLocation event: " + _location.toString());
  longitude = _location.getLongitude();
  latitude = _location.getLatitude();
}

